﻿#include "common.h"

enum ManagerType
{
    Mode_Simple,
    Mode_Report,
    Mode_ReportEx,
};

ManagerType g_ManagerMode = Mode_ReportEx;

int wmain()
{
	CoInitialize(NULL);
	HRESULT hr = S_OK;

    do
	{
		ICLRRuntimeHostPtr clrRuntimeHost;
		hr = CorBindToRuntimeEx(
			L"v2.0.50727", 
			NULL, // L"wks" or L"svr"
			0, //STARTUP_HOARD_GC_VM,
			CLSID_CLRRuntimeHost, 
			IID_ICLRRuntimeHost, 
			(PVOID*) &clrRuntimeHost);

		IHostControlPtr hostControl = NULL;

        switch( g_ManagerMode )
        {
        case Mode_Simple:
            hostControl = CreateHostControl<Simple>();
            break;
        case Mode_Report:
            hostControl = CreateHostControl<Report>();
            break;
        case Mode_ReportEx:
            hostControl = CreateHostControl<ReportEx>();
            break;
        }
        if( !clrRuntimeHost )
        {
            break;
        }

		hr = clrRuntimeHost->SetHostControl(hostControl);

		clrRuntimeHost->Start();

		// Test.Program.MyMain の実行
		// ExecuteInDefaultAppDomain は static int Function( string args ) というシグネチャを要求することに注意
		//   戻り値 void, 引数 string[] など微妙な違いで失敗する
		DWORD retVal = 0;
		hr = clrRuntimeHost->ExecuteInDefaultAppDomain( L"Test.dll", L"Test.Program", L"MyMain", L"Hello from host!", &retVal );

        hr = clrRuntimeHost->Stop();
	}
    while(false);

	CoUninitialize();

	return 0;
}


void DebugWriteLine( const wchar_t *format, ...)
{
	va_list args;
	va_start(args, format);
	{
		wchar_t buf[4096] = {L'\0'};
		vswprintf_s( buf, format, args );
		wchar_t buf2[4096] = {L'\0'};
		swprintf_s( buf2, L"%s\n", buf );
		OutputDebugString( buf2 );
	}
	va_end(args);
}
